{% extends "layout.html" %}

{% block head %}
<link rel="stylesheet" href="/static/croppie.min.css">
{% if graph %}
<link rel="stylesheet" href="/static/chartist.min.css">
<script src="/static/chartist.min.js"></script>
<script src="/static/chartist-plugin-legend.js"></script>
{% endif %}
{% endblock %}

{% block title %}
<a href="/people">People</a>
<div>
    {{person.full_name}}
    {% if person.is_contributor %}
    <span title="Contributor">🌟</span>
    {% endif %}
</div>
{% endblock %}


{% block body %}


<div class="columns wrap2">
<div class="rows3">
    <section class="card">
        <div style="float: right; margin: 0 0 var(--mar2) var(--mar3);">
            {% if update_avatar %}
            <script src="/static/croppie.min.js"></script>
            <div id="avatarPicker">
                <img id="avatarImage" src="{{person.avatar}}" class="avatar is-large">
                <input id="avatarInput" type="file" name="resume">
            </div>
            <div id="avatarFinalizer" style="display: none;">
                <div id="avatarEditor" style="width: 200px; height: 200px; margin-bottom: 40px;"></div>
                <div class="buttons wide">
                    <button id="avatarCancelButton" class="secondary">Cancel</button>
                    <button id="avatarUploadButton">Upload</button>
                    <form id="avatarForm" action="/people/{{person.id}}/avatar" method="post">
                        <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
                        <input name="avatar" id="avatarHiddenInput" type="hidden">
                    </form>
                </div>
            </div>
            {% else %}
            <img id="avatarImage" src="{{person.avatar}}" class="avatar is-large">
            {% endif %}
        </div>
        
        <h2 style="clear: none; margin-top: 0;">Personal details</h2>

        {% if edit_form %}
        {% from "form-macro.html" import form_macro with context %}
        {{ form_macro(edit_form, action) }}
        {% else %}
        <table>
            <tr><th>Full name</th><td>{{person.first_name}} {{person.last_name}}</td></tr>
            <tr><th>Short name</th><td>{{person.short_name}}</td></tr>
            <tr><th>Location</th><td>{{person.location or '-'}}</td></tr>
            <tr><th>Study coach</th><td>
                {% if person.coach %}
                <a href="{{ url_for('user_profile', short_name=person.coach.short_name) }}">
                    {{person.coach.full_name}}
                </a>        
                {% else %}
                -
                {% endif %}
            </td></tr>
            <tr><th>Language</th><td>{{"EN" if person.english else "NL"}}</td></tr>
            <tr><th>Current assignment</th><td>
                {% if person.current_attempt %}
                    <a href="/curriculum/{{person.current_attempt.node_id}}">{{person.current_attempt.node_id}}</a>
                {% else %}
                    -
                {% endif %}
            </td></tr>
            {% if current_user.is_teacher and not person.is_student %}
                <tr><th>BKE Certification</th><td>{{"✅" if person.bke_certification else "❌"}}</td></tr>
            {% endif %}
        </table>
        <table class="schedule">
            <tbody>
                <tr>
                    <th>Monday</th>
                    <th>Tuesday</th>
                    <th>Wednesday</th>
                    <th>Thursday</th>
                    <th>Friday</th>
                </tr>
                <tr>
                    {% for presence in person.default_schedule %}
                    <td class="{{presence}}">
                        {% if presence == 'present' %}
                            School 🎓
                        {% elif presence == 'home_structural' %}
                            Home 🏠
                        {% elif presence == 'absent_structural' %}
                            Absent 👻
                        {% else %}
                            Unknown ❓
                        {% endif %}
                    </td>
                    {% endfor %}
                </tr>
            </tbody>
        </table>
        {% endif %}
    </section>

    {% if performance and person.is_student %}
    <section class="card">
        <h2>Coaching notes</h2>
        {% if person.coach %}
        <div>Coach: {{current_user.coach.full_name}}</div>
        {% endif %}
        {% if current_user.is_teacher %}
        <form method="post" action="/user/set_leniency_targets/{{person.short_name}}" class="buttons">
            <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
            <textarea name="targets" placeholder="Student-visible notes here">{{ person.leniency_targets}}</textarea>
            <input role="button" type="submit" value="Save">
        </form>
        {% else %}
        <textarea readonly placeholder="Notes from your coach go here">{{person.leniency_targets|safe}}</textarea>
        {% endif %}
    </section>
    {% endif %}
    
    {% if performance and person.is_student %}
    <section class="card">
        <h2>Octant progress</h2>
        <table>
            <tr>
                <th>O</th>
                <th>Work days</th>
                <th colspan="2">Progress</th>
                <th colspan="2">Hours</th>
            </tr>
            {% for octant in performance.octants %}
            <tr>
                <td data-tooltip="{{octant.first | short_date}} - {{octant.last | short_date}}">{{octant.yq}}</td>
                <td>
                    {{octant.days}}
                </td>
                <td class="align-right">{{octant.progress}}</td>
                <td class="align-right">({{"%.1f" | format(100*octant.progress / (octant.days or 1))}}% pace)</td>
                <td class="align-right">{{octant.hours | round | int}}</td>
                <td class="align-right">({{"%.1f" | format(octant.hours / (octant.days or 1))}} daily)</td>
            </tr>
            {% endfor %}
        </table>
        <p>Target progress: <b>≥ 62.5%</b></p>

        {% if graph %}
        <div class="ct-chart mar2" style="border: 2px solid #8882; border-radius: 4px;"></div>
        <script>
            window.addEventListener('load', function() {
                let data = {{graph | json | safe}};
                new Chartist.Line('.ct-chart', data, {
                    plugins: Object.keys(data.series).length>1 ? [
                        Chartist.plugins.legend()
                    ] : [],
                    height: '300px',
                    low: 0
                });
            });
        </script>
        {% endif %}                
    </section>
    {% endif %}
</div>


<div class="rows3">
    {% if progress_chart and progress_chart.series %}
    <section class="card" style="overflow: visible;">
        <h2>ECTS</h2>
        <div class="ct-chart-donut">
            <div>
                {% for label in progress_chart["legend_labels"] %}
                <div class="ct-donut-legend">
                    <p class="ct-donut-legend-color"></p>
                    <p class="ct-donut-legend-label">{{ label }}</p>
                </div>
                {% endfor %}
                <a href="https://saxion.educator.eu/dashboard/student/{{ person.student_number }}" target="_blank">🦬 Bison</a>
            </div>
        </div>
    </section>
    <script>
        let chart = {{ progress_chart | json | safe }};
        new Chartist.Pie('.ct-chart-donut', chart, {
            donut: true,
            donutSolid: true,
            donutWidth: 40,
            showLabel: false
        });
    </script>
    {% endif %}
    {% if attempts != None %}
    <section class="card" id="attempts">
        {% if person.is_teacher %}
        <h2>Latest gradings</h2>
        {% else %}
        <h2>
            Latest attempts
        </h2>
        {% endif %}

        <table class="latest_attempts">
            <tr>
                <th>Attempt</th>
                {% if person.is_teacher %}
                <th>Student</th>
                {% else %}
                <th>Start</th>
                <th>Duration</th>
                {% endif %}
                <th>Grade</th>
            </tr>
            {% for attempt in attempts %}
            <tr class="{{attempt.status}}">
                <td>
                    <a href="/curriculum/{{attempt.node_id}}?student={{attempt.student_id}}#attempt_{{attempt.number}}">
                        {{attempt.node_id}} #{{attempt.number}}
                    </a>
                </td>
                {% if person.is_teacher %}
                <td>
                    {{attempt.student.short_name}}
                </td>
                {% else %}
                <td>
                    {{attempt.start_time | date}}
                </td>
                <td>
                    {{"%d:%02d" | format(attempt.hours,(attempt.hours * 60) % 60)}}
                </td>
                {% endif %}
                <td>
                {% if attempt.status == 'not_graded' %}
                    -
                {% elif attempt.status in ['needs_grading', 'needs_consent'] and attempt.grade_teacher %}
                    {{ attempt.grade_teacher.short_name }}
                {% elif attempt.status != 'needs_consent'%}
                    {{ attempt.latest_grading.grade }}
                {% endif %}
                </td>
            </tr>
            {% endfor %}
        </table>
        {% if current_user.is_teacher and not person.is_inspector %}
        <div class="buttons">
            <div style="display: flex; gap: var(--mar2); align-items: center;">
                <script>
                    function unset_check_in_teacher(e) {
                        let sel = document.getElementById('check_in_teacher');
                        sel.value='';
                        sel.dispatchEvent(new Event('change'));
                        event.preventDefault();
                    }
                </script>
                <a href="#" onclick="unset_check_in_teacher(event)">✓</a>
                <select id="check_in_teacher" name="check_in_teacher" hx-put="/people/{{person.id}}/check_in_teacher" hx-trigger="change" hx-swap="none">
                    <option value="">-</option>
                    {% for teacher in check_in_teachers %}
                        <option value="{{ teacher.id }}" {{ 'selected' if teacher.id == person.check_in_teacher_id else '' }}>
                            {{ teacher.short_name }}
                        </option>
                    {% endfor %}
                </select>
            </div>
            <a role="button" href="/curriculum{{person.url_query}}">Curriculum</a>
        </div>
        {% endif %}
    </section>
    {% endif%}

    {% if performance %}
    <section class="card">
        <h2>Presence and absence</h2>
        <table>
            <tr>
                <th>Date</th>
                <th>From</th>
                <th>Until</th>
                <th>Hours</th>
                <th>Absence reason</th>
            </tr>
            {% for day in performance.last_days %}
            <tr{{(' style="color: red;"' if day.suspicious else '') | safe}}>
                <td class="align-right">{{day.date | date}}</td>
                <td>{{day.start}}</td>
                <td>{{day.end}}</td>
                <td class="align-right">{{"%.1f" | format(day.get("hours",0))}}</td>
                {% if day.reason %}
                <td data-tooltip="{{day.reason.reason_history}}">
                    {{day.reason.reason}}
                </td>
                {% else %}
                <td></td>
                {% endif %}
            </tr>
            {% endfor %}
        </table>

        <form method="post" action="/user/report_absent/{{person.short_name}}" class="buttons">
            <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
            <input name="date" type="date" style="width: auto;">
            <script>document.currentScript.previousElementSibling.value = this.value || new Date().toISOString().split('T')[0]</script>
            <input name="reason" placeholder="Absence reason">
            <input type="submit" value="Set" style="width: auto;">
        </form>    
    </section>
    {% endif %}

    {% if current_user.is_admin %}
    <section class="card">
        <form method="post" action="/user/impersonate/{{person.short_name}}">
            <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
            <input role="button" class="is-important" type="submit" value="Impersonate">
        </form>
    </section>
    {% endif %}

    
    {% if discord_status %}
    <section class="card">
        <h2>Discord</h2>
        {% if discord_status != 'authorized' %}
            <a href="{{discord_url}}"><button type="submit">Link with Discord</button></a>
        {% else %}
            {% if current_user.is_student %}
                <label style="font-size: 1rem; font-weight: normal;">
                    <input type="checkbox" name="notification_same_exercise" hx-headers='{"X-CSRFToken": "{{ csrf_token() }}"}' hx-post="/discord/notifications/same_exercise" hx-swap="none" hx-trigger="input" {{'checked' if person.discord_notification_same_exercise else ''}}>
                    Notify when another student is working on the assignment you are working on.
                </label>

                <label style="font-size: 1rem; font-weight: normal;">
                    <input type="checkbox" name="notification_exam_reviewed" hx-headers='{"X-CSRFToken": "{{ csrf_token() }}"}' hx-post="/discord/notifications/exam_reviewed" hx-swap="none" hx-trigger="input" {{'checked' if person.discord_notification_exam_reviewed else ''}}>
                    Notify about exam grades.
                </label>

                <label style="font-size: 1rem; font-weight: normal;">
                    <input type="checkbox" name="notification_screen_recording" checked disabled>
                    Notify on exam screen recording problems. (Required.)
                </label>
            {% endif %}

            <div class="buttons">
                <form method="post" action="/discord/remove">
                    <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
                    <input role="button" class="outline" type="submit" value="Unlink Discord">
                </form>
            </div>
        {% endif %}
    </section>
    {% endif %}


    {% if person.internships|length > 0%}
    <section class="card">
        <h2>Internships</h2>
        <table>
            <tr>
                <th>Company</th>
                <th>Start</th>
                <th>End</th>
            </tr>
            {% for internship in person.internships %}
                <tr>
                    <td><a href="/companies/{{internship.company.id}}">{{internship.company.name}}</a></td>
                    <td>{{internship.start_date | date}}</td>
                    <td>{{internship.end_date | date}}</td>
                </tr>
            {% endfor %}
        </table>
    </section>
    {% endif %}

    <script>
        let croppie = new Croppie(document.getElementById('avatarEditor'), {
            viewport: {
                width: 200,
                height: 200,
                type: 'circle'
            },
            enableExif: true
        });
        function showFinalizer(val) {
            document.getElementById("avatarFinalizer").style.display = val ? "block" : "none";
            document.getElementById("avatarPicker").style.display = val ? "none" : "block";
        }
        document.getElementById("avatarInput").addEventListener("change", function(changeEvent) {
            let files = changeEvent.target.files;
            if (files && files[0]) {
                var reader = new FileReader();
                reader.onload = function (loadEvent) {
                    showFinalizer(true);
                    let editor = document.getElementById("avatarEditor");
                    editor.classList.add("ready");
                    croppie.bind({url: loadEvent.target.result});
                };
                reader.readAsDataURL(files[0]);
            }
        });
        document.getElementById("avatarCancelButton").addEventListener('click', function() {
            showFinalizer(false);
        });
        document.getElementById("avatarUploadButton").addEventListener('click', function() {
            croppie.result({type: 'base64', format: 'jpeg', circle: false}).then(function(base64) {
                document.getElementById("avatarHiddenInput").value = base64;
                document.getElementById("avatarForm").submit();
            })
        });
    </script>

</div>
</div>

{% endblock %}
